<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" :title="`Ir a ${typeContentSupport}`" v-on:clickEvent="modalReturnBtn  = true" style="margin-bottom:2.5rem"></ReturnButton>
    </header>
    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title="String(itemSupportMat.originalTitle).toUpperCase()"  bgColor="background-color: #818181 !important"> </app-title>
    </div>
    <el-row style="margin: 3rem 6rem;">
      <el-col :span="22" :offset="1">
        <h3 style="margin: 0 0 2rem"> OBSERVACIONES </h3>
        <el-input v-if="itemSupportMat.supportObj"
        type="textarea"
        :rows="4"
        v-model="itemSupportMat.supportObj.observations">
        </el-input>
        <el-input v-else
        type="textarea"
        :rows="4"
        v-model="observations">
        </el-input>
      </el-col>
    </el-row>
    <!-- CARDS  -->
    <el-row style="margin: 3rem 6rem;">
      <el-col :span="11" :offset="1">
        <el-collapse class="recept-accordion">
          <el-collapse-item class="recept-accordion-child">
            <template slot="title">
              <el-row>
                <el-col :span="20">
                  <div class="recept-accordion-title">
                    <i class="el-icon-caret-right"></i>
                    <div class="box-title">
                      <span class="title-accordion">{{itemSupportMat.originalTitle}}</span>
                    </div>
                  </div>
                  <div class="recept-accordion-status" v-if="itemSupportMat.supportObj">
                    <el-radio v-model="itemSupportMat.supportObj.status" label="Pendiente">Pendiente</el-radio>
                    <el-radio v-model="itemSupportMat.supportObj.status" label="Recibido">Recibido</el-radio>
                  </div>
                  <div class="recept-accordion-status" v-else>
                    <el-radio v-model="status" label="Pendiente">Pendiente</el-radio>
                    <el-radio v-model="status" label="Recibido">Recibido</el-radio>
                  </div>
                </el-col>
                <el-col :span="4" style="text-align: center; margin-top: 20px;">
                  <img src="../../../assets/images/borrador-rojo.svg" @click="showCleanModal = true">
                </el-col>
              </el-row>
            </template>
            <div>
              <el-row style="margin: 12px 0px 25px; background: #E0E0E0; padding: 2px 8px; font-size: 15px;">
                <el-col :span="12">
                  <h4 class="text-green"> COPIA DE BACK UP:</h4>
                </el-col>
                <el-col :span="4">
                  <el-radio v-if="itemSupportMat.supportObj" v-model="itemSupportMat.supportObj.copyBackUp" label="SÍ"> SÍ </el-radio>
                  <el-radio v-else v-model="copyBackUp" label="SÍ"> SÍ </el-radio>
                </el-col>
                <el-col :span="4">
                  <el-radio v-if="itemSupportMat.supportObj" v-model="itemSupportMat.supportObj.copyBackUp" label="NO"> NO </el-radio>
                  <el-radio v-else v-model="copyBackUp" label="NO"> NO </el-radio>
                </el-col>
              </el-row>
              <el-row style="margin: 12px 0;" type="flex" align="middle">
                <el-col :span="10" class="subtitles-chapter-form"> Fecha de llegada: </el-col>
                <el-col :span="14">
                  <el-date-picker style="width: 100%" v-if="itemSupportMat.supportObj"
                    v-model="itemSupportMat.supportObj.arrivalDate" type="date" format="dd/MM/yyyy" value-format="timestamp">
                  </el-date-picker>
                  <el-date-picker style="width: 100%" v-else
                  v-model="arrivalDate" type="date" format="dd/MM/yyyy" value-format="timestamp">
                  </el-date-picker>
                </el-col>
              </el-row>
              <el-row style="margin: 12px 0;" type="flex" align="middle">
                <el-col :span="10" class="subtitles-chapter-form"> Modo de envío: </el-col>
                <el-col :span="14">
                  <app-select v-if="itemSupportMat.supportObj" v-model="itemSupportMat.supportObj.shippingMode" :filterArray="modoDeEnvio"></app-select>
                  <app-select v-else v-model="shippingMode" :filterArray="modoDeEnvio"></app-select>
                </el-col>
              </el-row>
              <el-row style="margin: 12px 0;" type="flex" align="middle">
                <el-col :span="10" class="subtitles-chapter-form"> Soporte: </el-col>
                <el-col :span="14">
                  <app-select v-if="itemSupportMat.supportObj" v-model="itemSupportMat.supportObj.supportOption" :filterArray="typeSupport"></app-select>
                  <app-select v-else v-model="supportOption" :filterArray="typeSupport"></app-select>
                </el-col>
              </el-row>
            </div>
          </el-collapse-item>
        </el-collapse>
      </el-col>
    </el-row>
    <section style="margin:5rem 6rem 4rem 6rem">
      <el-row>
        <el-col :span="2" :offset="17">
          <el-button v-on:click="modalCancelButton = true" size="medium" type="primary" plain>CANCELAR </el-button>
        </el-col>
        <el-col :span="1" :offset="2">
          <el-button size="medium" @click="saveSupportData()" type="primary">
            <span v-if="itemSupportMat.supportObj">ACTUALIZAR </span>
            <span v-else>GUARDAR </span>
          </el-button>
        </el-col>
      </el-row>
    </section>

    <!-- Modal botón ingresar-->
    <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" :parrafo="'Se guardó la información del material ' + itemSupportMat.originalTitle"
      btn1="ACEPTAR" @btnEvent="enterSupportModal = false" v-on:btnEvent="returnPage" >
    </AppModalSuccess>
    <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

    <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage"  @btnEvent="modalReturnBtn = false" v-on:eventBtn="modalReturnBtn = false">
    </AppModalDanger> 

    <!-- Modal Limpiar inputs -->
    <app-modal :show-dialog.sync="showCleanModal" v-if="showCleanModal" nameClass="dialog-red" :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="65px" textBold="¡Un momento!"
      :parrafo="parrafoModal" classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR" @btnEvent="cleanInputs" v-on:eventBtn="showCleanModal = false" >
    </app-modal>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'
import SearchFilter from '@/components/searchFilter.vue'
import { HTTP } from '../../../main.js'
import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import { contentTypeSupport } from '@/enums.js'

export default {
  components: {
    ReturnButton,
    AppModalSuccess,
    AppModalDanger,
    'app-search-filter': SearchFilter,
    'app-title': Title,
    'app-select': Select,
    'app-modal': AppModal
  },
  data () {
    return {
      itemSupportMat: [],
      observations: '',
      status: 'Pendiente',
      arrivalDate: '',
      shippingMode: '',
      supportOption: '',
      copyBackUp: '',
      enterSupportModal: false,
      modoDeEnvio: [
        {value: 'Entrega a mano', label: 'Entrega a mano'}
      ],
      typeSupport: contentTypeSupport,
      modalCancelButton: false,
      showCleanModal: false,
      parrafoModal: '¿Seguro que quieres borrar la información ingresada?',
      edit: JSON.parse(this.$localStorage.get('edit')),
      itemStorage: {},
      indexStorage: 0,
      textSearch: '',
      idSupportMat: JSON.parse(this.$localStorage.get('idSupportMat')),
      season: [],
      selectItems: [],
      textarea3: '',
      checked: false,
      temporada: '',
      seasonFilterByTemp: {},
      radio: '',
      modalCopy: false,
      copy: 'copiar',
      indexTemp: 0,
      fusionGourmetSoporte: false, 
      modalReturnBtn: false,
      typeContentSupport: this.$localStorage.get('typeContentSupport'),// tipo de contenido
    }
  },
  created () {
    this.getSupportMaterials()
    this.fusionGourmetSoporte = this.$route.params.fusionGourmetSoporte
  },
  methods: {
    returnPage () {
      if(this.edit === 'edit') {
        if ( this.fusionGourmetSoporte === true ) {
          this.$router.push({ name: 'reportNational', params: { fusionGourmetSoporte: true } })
        }
        else {
          this.$router.push({ name: 'reportNational' })
        }        
      }
      else {
        if ( this.fusionGourmetSoporte === true ) {
          this.$router.push({ name: 'fusionGourmetSoporte' })
        }
        else {
          this.$router.push({name: 'nationalProduction'})
        }  
      }    
    },
    getSupportMaterials () {
      HTTP.get('materials/' + this.idSupportMat)
        .then(res => {
          this.itemSupportMat = res.data.material
        })
        .catch(err => {
          console.log(err)
        })
    },
    saveSupportData () {
      let supportInfo = {
        status: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.status : this.status,
        arrivalDate: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.arrivalDate : this.arrivalDate,
        copyBackUp: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.copyBackUp : this.copyBackUp,
        shippingMode: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.shippingMode : this.shippingMode,
        supportOption: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.supportOption : this.supportOption,
        observations: (this.itemSupportMat.supportObj) ? this.itemSupportMat.supportObj.observations : this.observations
      }
      HTTP.patch(`materials/update/${this.idSupportMat}`, [
        {propName: 'supportObj', value: supportInfo},
        {propName: 'stateBtnSupport', value: (supportInfo.status === 'Recibido') ? 'Recibido' : 'Pendiente'},
        {propName: 'colorBtnSupport', value: (supportInfo.status === 'Recibido') ? 'success' : 'info'}
      ])
        .then(res => {
          this.enterSupportModal = true
        })
        .catch(err => console.log(err))
    },
    cleanInputs () {
      if (this.itemSupportMat.supportObj) {
        this.itemSupportMat.supportObj.copyBackUp = ''
        this.itemSupportMat.supportObj.arrivalDate = ''
        this.itemSupportMat.supportObj.shippingMode = ''
        this.itemSupportMat.supportObj.supportOption = ''
        this.itemSupportMat.supportObj.status = 'Pendiente'
      } else {
        this.copyBackUp = ''
        this.arrivalDate = ''
        this.shippingMode = ''
        this.supportOption = ''
        this.status = 'Pendiente'
      }
      this.showCleanModal = false
    }
  }
}
</script>

<style>
.recept-accordion.el-collapse{
  border-top: 0px;
  border-bottom: 0px;
}
.recept-accordion-child > div[role="tab"] > div[role="button"]{
  font-size: 18px;
  font-weight: 500;
  padding: 5px 10px 5px 25px;
  border-bottom: 0;
  height: auto;
}
.recept-accordion-child > div[role="tab"]{
  border: 1px solid #C0C0C0;
  border-radius: 4px;
}
.recept-accordion-child > div[role="tab"] > div[role="button"]> .el-collapse-item__arrow{
  display: none;
}
.recept-accordion-child > div[role="tab"] > div[role="button"]> div > i{
  color: #828282;
  font-size: 28px;
  display: table-cell;
  vertical-align: middle;
}
.recept-accordion-child > div[role="tab"] > div[role="button"]> div >.box-title{
  display: table-cell;
  vertical-align: middle;
  padding-left: 10px;
}
.recept-accordion-child > div[role="tabpanel"]{
  border-bottom: 0;
  border-radius: 0px 0px 4px 4px;
  border: 1px solid #C0C0C0;
  padding: 20px 65px;
}
.recept-accordion-child{
  box-shadow: 3px 3px 10px #C0C0C0;
  margin-bottom: 30px;
  border-radius: 4px;
}
.recept-accordion-child.is-active > div[role="tab"] > div[role="button"]{
  background: #E0E0E0;
  color: #FF5000;
}
.recept-accordion-child.is-active > div[role="tab"] > div[role="button"] .box-title{
  color: black;
}
.recept-accordion-child> div[role="tab"] > div[role="button"] .box-title{
  margin-left: 10px;
}
.recept-accordion-child.is-active > div[role="tab"]{
  border-radius: 4px 4px 0 0;
}
.recept-accordion-child > div[role="tabpanel"] > .el-collapse-item__content{
  padding-bottom: 0px;
}
.recept-accordion-title>.box-title, .recept-accordion-title>i{
  display: inline-block;
}
.recept-accordion-status {
  margin-left: 28px
}
</style>
